// AecSony422.cpp : implementation file
//

#include "stdafx.h"
#include "AecMfc32TimeCode.h"
#include "AecSony422.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAecSony422 dialog




CAecSony422::CAecSony422(CWnd* pParent /*=NULL*/)
	: CDialog(CAecSony422::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAecSony422)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pMainDlg = pParent;
	UseLTC = TRUE;
	UseVITC = FALSE;
	UseCTL = FALSE;
	m_TCmsg = TCSENSE_LTC;

}


void CAecSony422::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAecSony422)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAecSony422, CDialog)
	//{{AFX_MSG_MAP(CAecSony422)
	ON_BN_CLICKED(IDC_XREW, OnXrew)
	ON_BN_CLICKED(IDC_XPLAY, OnXplay)
	ON_BN_CLICKED(IDC_XFFWD, OnXffwd)
	ON_BN_CLICKED(IDC_XPAUSE, OnXpause)
	ON_BN_CLICKED(IDC_XSTOP, OnXstop)
	ON_BN_CLICKED(IDC_XRECORD, OnXrecord)
	ON_BN_CLICKED(IDC_XGOTO, OnXgoto)
	ON_BN_CLICKED(IDC_XCTL, OnXctl)
	ON_BN_CLICKED(IDC_XLTC, OnXltc)
	ON_BN_CLICKED(IDC_XVITC, OnXvitc)
	ON_BN_CLICKED(IDC_XCLOSE_SONY, OnXCloseSony)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//	ON_MESSAGE(WM_AEC_TCUB, OnTCUpdate)

/////////////////////////////////////////////////////////////////////////////
// CAecSony422 message handlers

void CAecSony422::OnXrew() 
{

	//SendToMain(REW, 0);
	m_msg = REW;
	
	//m_pMainDlg->SendMessage(WM_AEC_REW, 0, 0);
	//m_pMainDlg->SendMessage(WM_AEC_SONY422, REW, 0);

/*
#define PLAY	1
#define STOP	2
#define REW		3
#define FWD 	4
#define PAUSE	5
#define RECORD	6
#define GOTO	7
#define CLOSE	8

#define TCVITC	10
#define TCLTC	11
#define TCCTL	12
#define STATUS	13
#define TCSENSE	14
#define TCSENSE_CTL 15
#define TCSENSE_LTC 16
#define TCSENSE_VITC 17

#define SHTL_FWD	20
#define SHTL_REV	21
#define JOG_FWD		22
#define JOG_REV		23
  */
	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXplay() 
{
	//SendToMain(PLAY, 0);
	m_msg = PLAY;
	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXffwd() 
{
	//SendToMain(FWD, 0);
	m_msg = FWD;
	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXpause() 
{
	//SendToMain(PAUSE, 0);	
	m_msg =  PAUSE;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXstop() 
{
	//SendToMain(STOP, 0);	
	m_msg = STOP;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXrecord() 
{
	//SendToMain(RECORD, 0);	
	m_msg = RECORD;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXgoto() 
{
	char sHH[3];
	char sMM[3];
	char sSS[3];
	char sFF[3];
	BYTE h, m, s, f;
	//LPARAM lpHMSF = 0x00334420;
	//SendToMain(GOTO, lpHMSF);	
	//IDC_XGOTOTIMEHH
	//IDC_XGOTOTIMEMM
	//IDC_XGOTOTIMESS
	//IDC_XGOTOTIMEFF
	GetDlgItemText(IDC_XGOTOTIMEHH, sHH, 3);
	GetDlgItemText(IDC_XGOTOTIMEMM, sMM, 3);
	GetDlgItemText(IDC_XGOTOTIMESS, sSS, 3);
	GetDlgItemText(IDC_XGOTOTIMEFF, sFF, 3);
	if (sHH[0] != 0)
		h = StrToByte(sHH);
	else h = 0;
	if (sMM[0] != 0)
		m = StrToByte(sMM);
	else m = 0;
	if (sSS[0] != 0)
		s = StrToByte(sSS);
	else s = 0;
	if (sFF[0] != 0)
		f = StrToByte(sFF);
	else f = 0;

	wsprintf (sHH,"%2.2X",h);
	SetDlgItemText(IDC_XGOTOTIMEHH, sHH);
	wsprintf (sMM,"%2.2X",m);
	SetDlgItemText(IDC_XGOTOTIMEMM, sMM);
	wsprintf (sSS,"%2.2X",s);
	SetDlgItemText(IDC_XGOTOTIMESS, sSS);
	wsprintf (sFF,"%2.2X",f);
	SetDlgItemText(IDC_XGOTOTIMEFF, sFF);



//	m = StrToByte(sMM);
//	s = StrToByte(sSS);
//	f = StrToByte(sFF);
	m_msgData = ((h * 0x1000000) + (m * 0x10000) + (s * 0x100) + f);//
	//m_msgData = 0x01020304;	//TEMP till get READING EDIT boxes handled.
	m_msg = GOTO;
}

BYTE CAecSony422::StrToByte(char *s)
{
	char tens, ones;
	BYTE tz, oz;
	if (s[1] != 0)	//if more that one char
	{
		tens = s[0];
		tz = (tens - 0x30);
		ones = s[1];
		oz = (ones - 0x30);
	}
	else
	{
		tz = 0;
		ones = s[0];
		oz = (ones - 0x30);
	}
	return (BYTE)((tz * 0x10) + oz);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXctl() 
{
	UseCTL = TRUE;
	UseLTC = FALSE;
	UseVITC = FALSE;
	//SendToMain(TCCTL, 0);	
	m_msg = TCCTL;
	m_TCmsg = TCSENSE_CTL;

}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXltc() 
{
	UseCTL = FALSE;
	UseLTC = TRUE;
	UseVITC = FALSE;
	//SendToMain(TCLTC, 0);	
	m_msg = TCLTC;
	m_TCmsg = TCSENSE_LTC;

}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXvitc() 
{
	UseVITC = TRUE;
	UseLTC = FALSE;
	UseCTL = FALSE;
	//SendToMain(TCVITC, 0);
	m_msg = TCVITC;
	m_TCmsg = TCSENSE_VITC;
	
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//DEL void CAecSony422::OnTCUpdate(WPARAM wParam, LPARAM lParam)
//DEL {
//DEL 	MessageBeep(-1);
//DEL }

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnXCloseSony() 
{
		//MessageBeep(-1);
	KillTimer(m_Sio_Timer);
	m_Sio_Timer = 0;
	Sleep(50);
	SendToMain(CLOSE, 0);	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::SendToMain(WPARAM wp, LPARAM lp)
{

	TxComplete = FALSE;
	RxComplete = FALSE;
	m_pMainDlg->SendMessage(WM_AEC_SONY422, wp, lp);

}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL CAecSony422::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//set to use LTC initially, set that radio
	if (UseLTC)
		GetDlgItem(IDC_XLTC)->SendMessage(BM_SETCHECK, 1, 0 );	//DEFAULT RADIO

	//initialize a timer here!
	
	Row0 = 0;
	Row1 = 0;
	Row2 = 0;
	Row3 = 0;
	Row4 = 0;
	Row5 = 0;
	Row6 = 0;
	Row7 = 0;
	Row8 = 0;
	m_rxIndex = 0;
	m_msg = 0;
	m_RxDataReady = false;
	RxComplete = true;
	TxComplete = true;
	m_timeout = false;
	m_error = false;
	m_tmr = 0;

	m_Sio_Timer = SetTimer(2, 200, 0);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::OnTimer(UINT nIDEvent) 
{
	char cnt[5];

	//CDialog::OnTimer(nIDEvent);
	
	int i = 0;
	UINT t;

	if (nIDEvent == 2)
	{
		if (m_RxDataReady)	//check for timeout and if RX complete
		{
			m_timeout = false;
			m_error = false;
			ChkReply();	//check it out	//updates the dialog box status
			//m_msgData = 0;
			//m_msg = 0;
			t = 5;
			RxComplete = true;
			TxComplete = true;
			m_RxDataReady = false;
		}

		//TxComplete, timeout... command button, automatic statux/time sense...
		//RxComplete. m_msg, m_msgData
		//m_getTC
		else if (TxComplete && RxComplete)	//ready for more SIO
		{
			m_RxEvent = false;
			m_tmr = 0;
			if (m_msg != 0)
			{
				m_msgLast = m_msg;
				m_msg = 0;
				SendToMain(m_msgLast, m_msgData);
			}
			else	//TCSENSE or STATUS
			{
				m_getTC = (m_getTC ? FALSE : TRUE );	//toggle request
				//m_msg = (m_getTC ? TCSENSE : STATUS );
				m_msg = (m_getTC ? m_TCmsg : STATUS );
				//m_msgData = 0;
				m_msgLast = m_msg;
				m_msg = 0;
				SendToMain(m_msgLast, m_msgData);
				//for STATUS: m_statCmd = 0x09 when NOT passing argument 
				m_statCmd = 0x09;
			}
			t = 4;	//timer to 4ms.		
			//m_msg = 0;
			
		}

	//	else if (m_RxDataReady)	//check for timeout and if RX complete
	//	{
	//		m_timeout = false;
	//		m_error = false;
	//		ChkReply();	//check it out	//updates the dialog box status
	//		//m_msgData = 0;
	//		//m_msg = 0;
	//		t = 15;
	//		RxComplete = true;
	//		TxComplete = true;
	//		m_RxDataReady = false;
	//
	//	}

		else
		{
			//wsprintf (cnt,"%d",m_tmr);
			//SetDlgItemText(IDC_EDIT1_TMR, cnt);
			t = 5;
			if (m_timeout)
			{
				MessageBox("Error, InterByteTimeout?", "RS422 I/O",MB_OK);
				RxComplete = true; //fix things up and try again
				TxComplete = true;
				//MessageBeep(-1);
				Sleep(1000);
				m_tmr = 0;	//temp
			}
			else if (m_error)
			{
				///MessageBeep(-1);
				MessageBox("Error, ParityFrameOverrun?", "RS422 I/O",MB_OK);
				m_tmr = 0;	//temp
				Sleep(3000);
				RxComplete = true; //fix things up and try again
				TxComplete = true;
			}
			
			else if (m_tmr >= TIMEOUT_SONY)	//adjust this value 
			//else if (m_tmr >= 1000)	//adjust this value 
			{
				//MessageBeep(-1);
				MessageBox("Timeout, no communications", "RS422 I/O", MB_ICONERROR);
				Sleep(5000);
				m_tmr = 0;	//temp
				RxComplete = true; //fix things up and try again
				TxComplete = true;
			}
		
		}
		
		//t = 3000;//TEMP
		//t = 500;//TEMP

		//MessageBeep(-1);
		//m_Sio_Timer = SetTimer(2, 100, 0);
		m_Sio_Timer = SetTimer(2, t, 0);
		m_tmr += t;
		//SetTimer(id,UNIT nElapse, NULL)
	}
	return;
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL CAecSony422::ProcessRxData()
{
	//See if timeout or if have finished receiving string
	//check m_rxW[0] low nibble for "len" to see if it matches
	// m_rxIndex...
	WB2 rx;
	int i, j, cks;
	BOOL	error = false;
	BOOL	timeout = false;

	rx.W = m_rxW[0];
	i = (int)(rx.B.L & 0x0F);
	if ((i + 3) <= m_rxIndex)	//if we have received at least a full reply
	{
		cks = 0;
		//process the string
		for (j = 0; j<(i+2); j++)
		{
			rx.W = m_rxW[j];
			//check the STATUS of each byte and add to sStatStr
			if ((rx.B.H & 0x7F) != 0)	//in not all OK
			{
				if (rx.B.H & 0x10)
				{
					//we have an RX timeout
					//m_tmr = TIMEOUT_SONY;
					MessageBeep(-1);
					return m_RxDataReady;	//no change
				}
				else
				{
					//we have an error
					m_rxIndex = 0;
					RxComplete = TRUE;
					m_RxEvent = FALSE;
					//m_tmr = TIMEOUT_SONY;
					return false;
				}
			}			
			else
			{
				sStatStr[j] = rx.B.L;
				cks += (int)rx.B.L;
			}
		}
		rx.W = m_rxW[j];
		if ((cks & 0x00FF) != (int)rx.B.L)
		{
			//bad checksum
			m_rxIndex = 0;
			RxComplete = TRUE;
			m_tmr = 0;
			return false;
		}
		else return true;
	}

	else 
	{
		for (j = 0; j<m_rxIndex; j++)
		{
			rx.W = m_rxW[j];
			//check the STATUS of each byte for errors
			if ((rx.B.H & 0x7F) != 0)	//in not all OK
			{
				if (rx.B.H & 0x10)
				{
					//we have an RX timeout
					timeout = true;
					//MessageBeep(-1);
				}
				else
				{
					//we have an error
					error = true;
				}
			}			
		}
		if (timeout)
		{
			if (m_rxIndex = 1)
			{
				m_timeout = false;
				RxComplete = TRUE;
			}
			else m_timeout = true;
			m_rxIndex = 0;
		}
		if (error)
		{
			m_error = true;
			m_rxIndex = 0;
		}
		return false;
	}	
}
/*
status: 
bit7 => 1 if status and data are valid
bit6 => 1 if some previous data was lost (buffer ovr)
bit5 => 1 if RESERVED
bit4 => 1 if Rx timeout
bit3 => 1 if framing error
bit2 => 1 if overrun error
bit1 => 1 if BREAK
bit0 => 1 if Parity error
  */

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//does the reply meet with expectations for command "m_msgLast"
BOOL CAecSony422::ChkReply()
{
	BOOL ok = true;
	switch (m_msgLast)
	{
		//ack 10 01 
		case PLAY:
		case STOP:
		case REW:
		case FWD:
		case PAUSE:
		case RECORD:
		case GOTO:

		case SHTL_FWD:
		case SHTL_REV:
		case JOG_FWD:
		case JOG_REV:

		case EJECT:
		case TCVITC:	//UseTC
		case TCLTC:		//UseTC
		case TCCTL:		//UseCtl
			if ((sStatStr[0] == 0x10) && (sStatStr[1] == 0x01))
				ok = true;
			else ok = false;
			//m_rxIndex = 0;
			break;

		case STATUS:	//7x 20  len depends upon request! "m_statCmd"
			//m_statCmd holds the requested length/number of bytes
			if ((m_statCmd & 0x0F) != (sStatStr[0] & 0x0F))
				ok = false;
			else ProcessStatus();
			//m_rxIndex = 0;
			
			break;
		case TCSENSE:	//74 00 = Tmr, x4 = LTC, x? = VITC
		case TCSENSE_CTL:
		case TCSENSE_LTC:
		case TCSENSE_VITC:
			if (sStatStr[0] != 0x74)
				ok = false;
			else ProcessTC();
			//m_rxIndex = 0;
			break;
		default:	//NAK(=11 12 xx),   or NOT  handled
			break;
	}
	m_rxIndex = 0;
	return ok;
}




// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Receive the number (len) of bytes and process them
//The 's' will have high byte as STATUS and low byte as DATA
// 'len' is number of WORDs (ie: status/data pairs)
void CAecSony422::ReceiveData(int len, LPWORD s)
{
	char cnt[10];

	TxComplete = TRUE;	//we won't get a response till the transmission was received by
						//the slave device (ie: VTR...)
	for (int i =0; i<len; i++)
	{
		//wsprintf (cnt,"%d",m_rxIndex);
		//SetDlgItemText(IDC_EDIT1_INDEX, cnt);

		if (m_rxIndex > 19)
		{
			//something has gone wrong!)
			m_rxIndex = 0;
			m_RxEvent = FALSE;
			m_tmr = TIMEOUT_SONY;
			RxComplete = TRUE;
			return;
		}
		m_rxW[m_rxIndex] = s[i];
		m_rxIndex++;
	}
	m_tmr = 0;	//reset timer to 0
	m_RxEvent = TRUE;
	m_RxDataReady = ProcessRxData();

}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

BOOL CAecSony422::ProcessTC()
{
	DWBYTESs tm;
	char hmsf[13];
	tm.b.f = sStatStr[2];
	tm.b.s = sStatStr[3];
	tm.b.m = sStatStr[4];
	tm.b.h = sStatStr[5];
	wsprintf (hmsf,"%8.8X",tm.d);
	hmsf[11] = 0;	//EOL
	hmsf[10] = hmsf[7];
	hmsf[9] = hmsf[6];
	hmsf[8] = ':';
	hmsf[7] = hmsf[5];
	hmsf[6] = hmsf[4];
	hmsf[5] = ':';
	hmsf[4] = hmsf[3];
	hmsf[3] = hmsf[2];
	hmsf[2] = ':';
	if (strcmp(m_hmsf, hmsf))
	//if (m_hmsf ! hmsf)	
	{
		strcpy(m_hmsf, hmsf);
		SetDlgItemText(IDC_XTIMEDATA, hmsf);
	}
	return true;
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::SetStatus(BYTE bStatBit, int nID)	// identifier of control
{
	GetDlgItem(nID)->SendMessage(BM_SETCHECK, (bStatBit  ? 1 : 0 ), 0);
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSony422::ProcessRow(BYTE bBits, int StatRow) 	//bit field, row
{
	if (StatRow == 0)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW0_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW0_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW0_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW0_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW0_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW0_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW0_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW0_B0);
	}
	else if (StatRow == 1)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW1_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW1_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW1_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW1_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW1_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW1_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW1_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW1_B0);
	}
	else if (StatRow == 2)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW2_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW2_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW2_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW2_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW2_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW2_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW2_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW2_B0);
	}
	else if (StatRow == 3)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW3_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW3_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW3_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW3_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW3_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW3_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW3_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW3_B0);
	}
	else if (StatRow == 4)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW4_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW4_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW4_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW4_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW4_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW4_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW4_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW4_B0);
	}
	else if (StatRow == 5)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW5_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW5_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW5_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW5_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW5_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW5_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW5_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW5_B0);
	}
	else if (StatRow == 6)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW6_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW6_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW6_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW6_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW6_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW6_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW6_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW6_B0);
	}
	else if (StatRow == 7)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW7_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW7_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW7_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW7_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW7_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW7_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW7_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW7_B0);
	}
	else if (StatRow == 8)
	{
		SetStatus((bBits & BIT7), IDC_X_ROW8_B7);
		SetStatus((bBits & BIT6), IDC_X_ROW8_B6);
		SetStatus((bBits & BIT5), IDC_X_ROW8_B5);
		SetStatus((bBits & BIT4), IDC_X_ROW8_B4);
		SetStatus((bBits & BIT3), IDC_X_ROW8_B3);
		SetStatus((bBits & BIT2), IDC_X_ROW8_B2);
		SetStatus((bBits & BIT1), IDC_X_ROW8_B1);
		SetStatus((bBits & BIT0), IDC_X_ROW8_B0);
	}
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Process the Status string that the VTR has returned and update the status flags
// This program was written such that the status is hard coded to ask for status
// bytes 0 through 8 (nine bytes total) and so this function processes the string as
// if this is the case
// SEND (master) [61][20][xx][cks], RECEIVE (from slave/vtr) [7x][20][d1]...[dx][cks]
//NOTE: m_statCmd below is the same as [xx] from command!
BOOL CAecSony422::ProcessStatus()
{
	//static BYTE Row0, Row1, Row2, Row3, Row4, Row5, Row6, Row7, Row8;
	BYTE Rw0, Rw1, Rw2, Rw3, Rw4, Rw5, Rw6, Rw7, Rw8;
	int nLen, i;
	BYTE nFirst;

	
	if ((sStatStr[0] & 0x70) != 0x70)
		return FALSE;	//did not receive data properly
	if (sStatStr[1]  != 0x20)
		return FALSE;	//did not receive data properly

	//This is currently set up to ONLY handle status 
	//message bytes 0-8
	nLen = (int)(sStatStr[0] & 0x0F);
	//now get the FIRST status that was requested from m_statCmd
	nFirst = (m_statCmd & 0xF0);

	i = 0;	//first data in the index
	switch (nFirst)
	{
		case 0x00:
			Rw0 = sStatStr[i+2];
			if (Rw0 != Row0)
			{
				ProcessRow(Rw0, 0);	//bit field, row
				Row0 = Rw0;
			}
			i++;
			if (i == nLen)
				break;
		case 0x10:
			Rw1 = sStatStr[i+2];
			if (Rw1 != Row1)
			{
				ProcessRow(Rw1, 1);	//bit field, row
				Row1 = Rw1;
			}
			i++;
			if (i == nLen)
				break;
		case 0x20:
			Rw2 = sStatStr[i+2];
			if (Rw2 != Row2)
			{
				ProcessRow(Rw2, 2);	//bit field, row
				Row2 = Rw2;
			}
			i++;
			if (i == nLen)
				break;
		case 0x30:
			Rw3 = sStatStr[i+2];
			if (Rw3 != Row3)
			{
				ProcessRow(Rw3, 3);	//bit field, row
				Row3 = Rw3;
			}
			i++;
			if (i == nLen)
				break;
		case 0x40:
			Rw4 = sStatStr[i+2];
			if (Rw4 != Row4)
			{
				ProcessRow(Rw4, 4);	//bit field, row
				Row4 = Rw4;
			}
			i++;
			if (i == nLen)
				break;
		case 0x50:
			Rw5 = sStatStr[i+2];
			if (Rw5 != Row5)
			{
				ProcessRow(Rw5, 5);	//bit field, row
				Row5 = Rw5;
			}
			i++;
			if (i == nLen)
				break;
		case 0x60:
			Rw6 = sStatStr[i+2];
			if (Rw6 != Row6)
			{
				ProcessRow(Rw6, 6);	//bit field, row
				Row6 = Rw6;
			}
			i++;
			if (i == nLen)
				break;
		case 0x70:
			Rw7 = sStatStr[i+2];
			if (Rw7 != Row7)
			{
				ProcessRow(Rw7, 7);	//bit field, row
				Row7 = Rw7;
			}
			i++;
			if (i == nLen)
				break;
		case 0x80:
			Rw8 = sStatStr[i+2];
			if (Rw8 != Row8)
			{
				ProcessRow(Rw8, 8);	//bit field, row
				Row8 = Rw8;
			}
			i++;
			if (i == nLen)
				break;
		case 0x90:
		case 0xA0:
		case 0xB0:
		case 0xC0:
		case 0xD0:
		case 0xE0:
		case 0xF0:
		default:
			break;
	}
	return TRUE;
}


