
//wm_aec.h 
//
//			This header file holds message passing values for passing data/action
//			between the dialog boxes of this program
/*
struct B4		// Defines a structure 
{
    BYTE f;		//this order is important!
	BYTE s;
	BYTE m;
	BYTE h;    
} ;

struct W2		// Defines a structure 
{
    WORD sf;	//this order is important!
	WORD hm;
} ;
union DWBYTES	// Declare union type
{
	W2  w;
	B4	b;
	DWORD d;
} ;
*/


struct B2x		// Defines a structure 
{
    BYTE L;		//this order is important!
	BYTE H;
  
} ;

union WB2    // Declare union type
{
	WORD W;
	B2x	B;
} ;


struct DW4		// Defines a structure 
{
    DWORD d0;		//this order is important!
	DWORD d1;
	DWORD d2;
	DWORD d3;
} ;

union D4B16
{
	BYTE b[16];
	DW4  dw;	//.0, .1, .2, .3
} ;
	


#define BIT7	0x80
#define BIT6	0x40
#define BIT5	0x20
#define BIT4	0x10
#define BIT3	0x08
#define BIT2	0x04
#define BIT1	0x02
#define BIT0	0x01
#define NOTBIT7	0x7F
#define NOTBIT6	0xBF
#define NOTBIT5	0xDF
#define NOTBIT4	0xEF
#define NOTBIT3	0xF7
#define NOTBIT2	0xFB
#define NOTBIT1	0xFD
#define NOTBIT0	0xFE

#define CLOSE	500
#define TIMEOUT_SONY 50


#define WM_AEC_OSD	(WM_USER + 80)

//for use with RS422 dialog
		//FROM MAIN TO DIALOG
#define WM_AEC_TCUB		(WM_USER + 120)
#define WM_AEC_STATUS	(WM_USER + 121)

		//FROM DIALOG TO MAIN
#define WM_AEC_SONY422	(WM_USER + 100)
#define PLAY	1
#define STOP	2
#define REW		3
#define FWD 	4
#define PAUSE	5
#define RECORD	6
#define GOTO	7

#define EJECT 	9

#define TCVITC	10
#define TCLTC	11
#define TCCTL	12
#define STATUS	13
#define TCSENSE 14
#define TCSENSE_CTL 15
#define TCSENSE_LTC 16
#define TCSENSE_VITC 17

#define SHTL_FWD	20
#define SHTL_REV	21
#define JOG_FWD		22
#define JOG_REV		23




//=========================================
//for use with SIO dialog
		//FROM MAIN TO DIALOG
#define WM_AEC_RX		(WM_USER + 220)
#define WM_AEC_TX		(WM_USER + 221)

		//FROM DIALOG TO MAIN
#define WM_AEC_SIO		(WM_USER + 200)
#define CMD			40
#define WRITE_0		70
#define WRITE_1		71
#define WRITE_2		72
#define WRITE_3		73
#define BAUD		0x3C
#define BITSPARITY  0x3D
#define TIMEOUT		0x3E

#define STUFF_0		0x90
#define TX_0		0xA0
#define STUFF_1		0x91
#define TX_1		0xA1
#define STUFF_2		0x92
#define TX_2		0xA2
#define STUFF_3		0x93
#define TX_3		0xA3
#define STUFF_4		0x94
#define TX_4		0xA4
#define STUFF_5		0x95
#define TX_5		0xA5
#define STUFF_6		0x96
#define TX_6		0xA6
#define STUFF_7		0x97
#define TX_7		0xA7
#define STUFF_8		0x98
#define TX_8		0xA8
#define STUFF_9		0x99
#define TX_9		0xA9
#define STUFF_A		0x9A
#define TX_A		0xAA
#define STUFF_B		0x9B
#define TX_B		0xAB
#define STUFF_C		0x9C
#define TX_C		0xAC
#define STUFF_D		0x9D
#define TX_D		0xAD
#define STUFF_E		0x9E
#define TX_E		0xAE
#define STUFF_F		0x9F
#define TX_F		0xAF



#define PARAMETERS	40

//=========================================
//for use with L21 dialog
		//FROM MAIN TO DIALOG
#define WM_AEC_L21_UPDATE	(WM_USER + 420)

		//FROM DIALOG TO MAIN
#define WM_AEC_L21		(WM_USER + 400)
#define C1		0x11
#define C2		0x12
#define T1		0x21
#define T2		0x22
#define XDS		0x33
//#define C3		0x
//#define C4		0x
//#define T3		0x
//#define T4		0x


/*
Content Ratings via XDS Notes:
(7bit characters)
Character#2                 Character#1
b6 b5   b4 b3   b2 b1 b0        b6 b5   b4 b3 b2 b1 b0
 1 (F)V  S L/a3 g2 g1 g0         1 D/a2 a1 a0 r2 r1 r0        

#define MPAA_C1S0  0x58 //=0x40		//          a1=0,a0=0	x1x00xxx
#define MPAA_C2S0  0x47 //=0x40		//                      x1xxx000
#define USTV_C1S1  0x5F //=0x48		//          a1=0,a0=1	x1x01000
#define USTV_C2S1  0x40 //=0x40		//                      x1??????
#define MPAA_C1S2  0x58 //=0x50		//          a1=1,a0=0	x1x10xxx
#define MPAA_C2S2  0x //=0x		//                      x1xxx000
#define CANE_C1S3  0x //=0x		//a3=0,a2=0,a1=1,a0=1	x1011000
#define CANE_C2S3  0x //=0x		//                      x1000
#define CANF_C1S4  0x //=0x		//a3=0,a2=1,a1=1,a0=1	x1111000
#define CANF_C2S4  0x //=0x		//                      x1000
#define RES_C1S5   0x //=0x		//a3=1,a2=0,a1=1,a0=1	x1011000
#define RES_C2S5   0x //=0x		//                      x1
#define RES_C1S6   0x //=0x		//a3=1,a2=1,a1=1,a0=1	x1111000
#define RES_C2S6   0x //=0x		//                      x1



#define MPAA_NA    0x00		//                      xxxxx000
#define MPAA_G     0x01		//                      xxxxx001
#define MPAA_PG    0x02		//                      xxxxx010
#define MPAA_PG13  0x03		//                      xxxxx011
#define MPAA_R     0x04		//                      xxxxx100
#define MPAA_NC17  0x05		//                      xxxxx101
#define MPAA_X     0x06		//                      xxxxx110
#define MPAA_NOT   0x07		//                      xxxxx111



#define USTV_NONE0 0x00		//                      
#define USTV_TVY   0x01		//                      
#define USTV_TVY7  0x02		//FV=2.5                     
#define USTV_TVG   0x03		//                      
#define USTV_TVPG  0x04		//V=2.5,S=2.4,L=2.3,D=1.5
#define USTV_TV14  0x05		//V=2.5,S=2.4,L=2.3,D=1.5
#define USTV_TVMA  0x06		//V=2.5,S=2.4,L=2.3
#define USTV_NONE7 0x07		//                      

#define USTV_TEXT_NONE0 'None'
#define USTV_TEXT_TVY   'TV-Y'
#define USTV_TEXT_TVY7  'TV-Y7'
#define USTV_TEXT_TVG   'TV-G'
#define USTV_TEXT_TVPG  'TV-PG'
#define USTV_TEXT_TV14  'TV-14'
#define USTV_TEXT_TVMA  'TV-MA'
#define USTV_TEXT_NONE7 'None'

#define US_FV 'Fantasy Violence'
#define US_V  'Violence'
#define US_S  'Sexual Situations'
#define US_L  'Adult Language'
#define US_D  'Sexually Suggestive Dialog'

//from Char2, bits 0-2
#define CANE_E    0x00		//
#define CANE_C    0x01		//
#define CANE_C8   0x02		//
#define CANE_G    0x03		//
#define CANE_PG   0x04		//
#define CANE_14   0x05		//
#define CANE_18   0x06		//
//#define CANE_E  0x07		//


#define CANE_TEXT_E    'Exempt'
#define CANE_TEXT_C    'Children'
#define CANE_TEXT_C8   'Children eight years and older'
#define CANE_TEXT_G    'General programing, suitable for all audiences'
#define CANE_TEXT_PG   'Parental Guidence'
#define CANE_TEXT_14   'Viewers 14 years and older'
#define CANE_TEXT_18   'Adult Programming'
//#define CANE_TEXT_E  '






//=========================================================
		*** CLOSED CAPTIONING NOTES ***

Screen format:
	Display area: 
15 rows 
32 colums
vertical line 43-237 of Field 1 (195 lines)


Caption can display on up to 4 lines at one time.
The receiver remembers the cursor position
 1) Screen addressing
     caption mode - Both Row&Column
	 text mode - Only column
	 a) Preamble Adress code (PAC)
	    Indent is 4 space(columns)/each
	 b) Tab offset moves 1/2/3 columns to right
	    Does NOT typeover in the action of move
 2) Caption MODE
 		Any backspace or typeover will erase prior
		Display memory is cleared if change of mode
		or channels or if receive "Erase display Memory
		command.
		An "end of caption" command will toggle the display
		either on or off but does NOT erase from memory
    a)roll-on
		-> Initiated by receipt of one of three Misc Cont codes
			that determine the maximum number of rows displayed 
			simultaneously either 2/3/4 contiguous rows Command
		-> Bottom row is the "base" row, new row causes prior
			row to move UP and the new is started at beginning of BASE
		-> A PAC command will follow and set the BASE row & INDENT
		-> ROW 15 is default BASE or use base set prior
		-> Change of BASE will cause display to move to new base
			AS IS.
		-> A Carriage Return will cause lines to roll UP one
		-> Rows do NOT advance without a CR/PAC... and characters
			will typeover at the last column till then!

	b)pop-on
		-> Initiated by "Resume Caption Loading" command
			or by "End of Caption" command
		-> Recieved data is buffered (not displayed) until
			an "End of Caption" command is received and then
			the data display buffers are flipped (change what
			is displayed)
		-> PAC codes set the character positions (at random possibly)
		-> CR does nothing
		-> Character at last column are typed over if characters are 
			received prior to cursor move via PAC
		-> "Delete to End of Row" will clear the display memory
			of the current row to the right of the current column
		-> If interrupted, loading continues at current possition
			upon receipt of "Resume Caption Loading" (if no PAC follows)
		-> Buffer will be erased if receive "Erase Non-Displayed Memory"
			command, or Caption mode changes (ie: Roll-up command is received)
			or if change to data channels or selected field or upon loss of
			valid data
		-> Pop-on that is displayed until it is erased by standard
			techniques or a Roll-up command mode change is received.

	c)paint-on	
		-> Initiated by "Resume Direct Captioning" command
		-> Data is displayed upon receipt (not buffered)
		-> PAC codes set the character positions (at random possibly)
		-> CR does nothing
		-> Character at last column are typed over if characters are 
			received prior to cursor move via PAC
		-> "Delete to End of Row" will clear the display memory
			of the current row to the right of the current column
		-> Same as "pop-on" that has been displayed

//========================================================

Special Characters (two byte code): See table
   Data Channel 1 -> 11h 3xh
   Data Channel 2 -> 19h 3xh

Standard Characters: 
 values of 20h <--> 7Fh allowed and supported

//========================================================

  Character Attributes: (4 possible)
Color/Italic/Underline/Flash (flash is "blinking")
These are set by control codes
White/non-underlined is the default
Priortiy (high to low)
  Color - Italics - underline - flash..

The flash attribute is set by Misc Cont. Code
The "Flash On" Command will not alter status
of color, underline or italic but a color/italic/underline
 Mid-Row code will turn off FLASH.

//========================================================

Control Code:
 1) These control => format/location/attributes/display
 2) Always are transmitted in PAIRS (two byte codes)
	a) first byte is value 1xh, 2nd char is 20h-7Fh
	b) if first byte is 0xh-0Fh, then 2nd byte is NORMAL
	c) 2nd byte must have odd parity or it is ignored
	d) If 1st byte does NOT pass parity, insert solid block (7Fh)
 3) Normally Transmitted TWICE back to back (ie: in a row)

	a) Preamble Address Codes
	b) Mid-Row codes
	c) Miscellaneous Control Codes
	
//========================================================  

Mid-Row Codes:
1st Channel	2nd Channel	Attribute
11h 20h		19h 20h		White
11h 21h		19h 21h		White Underline
11h 22h		19h 22h		Green
11h 23h		19h 23h		Green Underline
11h 24h		19h 24h		Blue
11h 25h		19h 25h		Blue Underline
11h 26h		19h 26h		Cyan
11h 27h		19h 27h		Cyan Underline
11h 28h		19h 28h		Red
11h 29h		19h 29h		Red Underline
11h 2Ah		19h 2Ah		Yellow
11h 2Bh		19h 2Bh		Yellow Underline
11h 2Ch		19h 2Ch		Magenta
11h 2Dh		19h 2Dh		Magenta Underline
11h 2Eh		19h 2Eh		Italics
11h 2Fh		19h 2Fh		Italics Underline

//========================================================

Miscellaneous Control Codes:
1st Channel	2nd Channel	Mnemonic	Command Desc.
14h 20h		1Ch 20h		RCL			Resume Caption Coading
14h 21h		1Ch 21h		BS			Backspace
14h 22h		1Ch 22h		AOF			Reserved (was Alarm off)
14h 23h		1Ch 23h		AON			Reserved (was Alarm on)
14h 24h		1Ch 24h		DER			Delete to End of Row
14h 25h		1Ch 25h		RU2			Roll-Up two Rows
14h 26h		1Ch 26h		RU3			Roll-Up three Rows
14h 27h		1Ch 27h		RU4			Roll-Up four Rows
14h 28h		1Ch 28h		FON			Flash On
14h 29h		1Ch 29h		RDC			Resume Direct Captioning
14h 2Ah		1Ch 2Ah		TR			Text Restart
14h 2Bh		1Ch 2Bh		RTD			Resume Text Display
14h 2Ch		1Ch 2Ch		EDM			Erase Displayed Memory
14h 2Dh		1Ch 2Dh		CR			Carriage Return
14h 2Eh		1Ch 2Eh		ENM			Erase Non-Displayed Memory
14h 2Fh		1Ch 2Fh		EOC			End of Caption (flip memories)
17h 21h		1Fh 21h		TO1			Tab Offset 1 Column
17h 22h		1Fh 21h		TO2			Tab Offset 2 Columns
17h 23h		1Fh 23h		TO3			Tab Offset 3 Columns

//========================================================

Preamble Address Codes: See table
Data Channel 1		Data Channel 2
(data byte pairs)
10h-17h / 40h-5Fh	18h-1Fh / 60h-7Fh

These values set the ROW/COLOR/INDENT/UNDERLINE status of
the bytes that follow.

*/



