#if !defined(AFX_AECSONY422_H__791D7802_DBDD_412E_90B9_53473AF7B6EF__INCLUDED_)
#define AFX_AECSONY422_H__791D7802_DBDD_412E_90B9_53473AF7B6EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AecSony422.h : header file
//

struct B4s		// Defines a structure 
{
    BYTE f;		//this order is important!
	BYTE s;
	BYTE m;
	BYTE h;    
} ;

struct W2s		// Defines a structure 
{
    WORD sf;	//this order is important!
	WORD hm;
} ;
union DWBYTESs	// Declare union type
{
	W2s  w;
	B4s	b;
	DWORD d;
} ;

/////////////////////////////////////////////////////////////////////////////
// CAecSony422 dialog

class CAecSony422 : public CDialog
{
// Construction
public:
	volatile BOOL TxComplete;
	void ReceiveData(int len, LPWORD s);
	CAecSony422(CWnd* pParent = NULL);   // standard constructor
	BOOL ProcessStatus();

// Dialog Data
	//{{AFX_DATA(CAecSony422)
	enum { IDD = IDD_SONY_422_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAecSony422)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAecSony422)
	afx_msg void OnXrew();
	afx_msg void OnXplay();
	afx_msg void OnXffwd();
	afx_msg void OnXpause();
	afx_msg void OnXstop();
	afx_msg void OnXrecord();
	afx_msg void OnXgoto();
	afx_msg void OnXctl();
	afx_msg void OnXltc();
	afx_msg void OnXvitc();
	afx_msg void OnXCloseSony();
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL m_error;
	BOOL m_timeout;
	char m_hmsf[13];
	BYTE StrToByte(char* s);
	BOOL m_RxDataReady;
	BOOL m_RxEvent;
	WPARAM m_TCmsg;
	BOOL ProcessTC();
	BYTE m_statCmd;
	BOOL ChkReply();
	volatile UINT m_tmr;
	BYTE sStatStr[20];
	int m_rxIndex;
	WORD m_rxW[20];
	BOOL ProcessRxData();
	BOOL m_getTC;
	LPARAM m_msgData;
	WPARAM m_msg;
	WPARAM m_msgLast;
	volatile BOOL RxComplete;
	BYTE Row0, Row1, Row2, Row3, Row4, Row5, Row6, Row7, Row8;
	void SetStatus(BYTE bStatBit, int  nID);
	void ProcessRow(BYTE bBits, int StatRow);
	UINT m_Sio_Timer;
	BOOL UseLTC;
	BOOL UseVITC;
	BOOL UseCTL;
	void SendToMain(WPARAM wp, LPARAM lp);
	CWnd* m_pMainDlg;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AECSONY422_H__791D7802_DBDD_412E_90B9_53473AF7B6EF__INCLUDED_)
